'use strict';

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _babelCore = require('babel-core');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _powerAssert = require('power-assert');

var _powerAssert2 = _interopRequireDefault(_powerAssert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-env mocha */

var exampleFile = _fs2.default.readFileSync(_path2.default.join(__dirname, 'data', 'ExampleReducer.js')).toString();

var exampleTranspiledFileName = _path2.default.join(__dirname, 'data', 'ExampleReducerTranspiled.js');

var pluginPath = _path2.default.join(__dirname, '..', '..', 'index.js');

var babelConfig = {
    plugins: ['syntax-flow', 'syntax-decorators', pluginPath]
};

describe('patternMatchingBabelPluginTest', function () {
    it('test successful for ExampleReducer', function () {
        var _transform = (0, _babelCore.transform)(exampleFile, babelConfig);

        var code = _transform.code;

        _fs2.default.writeFileSync(exampleTranspiledFileName, code);
        var exampleTranspiledFile = _fs2.default.readFileSync(exampleTranspiledFileName).toString();
        (0, _powerAssert2.default)(_powerAssert2.default._expr(_powerAssert2.default._capt(_powerAssert2.default._capt(code, 'arguments/0/left') === _powerAssert2.default._capt(exampleTranspiledFile, 'arguments/0/right'), 'arguments/0'), {
            content: 'assert(code === exampleTranspiledFile)',
            filepath: 'src/plugin/__tests__/patternMatchingBabelPluginTest.js',
            line: 28
        }));
    });
});
//# sourceMappingURL=patternMatchingBabelPluginTest.js.map