'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
var findReducerExpressionVisitor = exports.findReducerExpressionVisitor = {
    ExpressionStatement: function ExpressionStatement(path, state) {
        var expr = path.node.expression;
        if (expr.type === 'CallExpression' && expr.callee.name === state.reducerLabel) {
            state.expressionParentPath = path;
            state.expression = expr;
        }
    }
};

var findReducerPropertyVisitor = {
    'ClassMethod|ObjectMethod|FunctionDeclaration': function ClassMethodObjectMethodFunctionDeclaration(path, state) {
        var propState = {
            reducerLabel: state.reducerLabel,
            expressionParentPath: null,
            expression: null
        };
        path.traverse(findReducerExpressionVisitor, propState);
        if (propState.expression) {
            state.prop = path;
            state.expressionParentPath = propState.expressionParentPath;
            state.expression = propState.expression;
        }
    }
};

exports.default = findReducerPropertyVisitor;
//# sourceMappingURL=findReducerPropertyVisitor.js.map