'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = generateSwitchCase;
function generateCase(_ref) {
    var args = _ref.args;
    var method = _ref.method;
    var t = _ref.t;
    var thisRef = _ref.thisRef;
    var types = _ref.types;

    return types.map(function (type, index) {
        var ret = [];
        if (index === types.length - 1) {
            ret.push(t.returnStatement(t.callExpression(t.memberExpression(thisRef, t.identifier(method)), args)));
        }
        return t.switchCase(t.identifier(type), ret);
    });
}

function generateSwitchCase(_ref2) {
    var args = _ref2.args;
    var switchArg = _ref2.switchArg;
    var t = _ref2.t;
    var thisRef = _ref2.thisRef;
    var typesMap = _ref2.typesMap;

    return t.switchStatement(t.memberExpression(switchArg, t.identifier('constructor')), typesMap.reduce(function (cases, _ref3) {
        var types = _ref3.types;
        var method = _ref3.method;

        return cases.concat(generateCase({
            args: args,
            method: method,
            t: t,
            thisRef: thisRef,
            types: types
        }));
    }, []).concat([t.switchCase(null, [t.breakStatement()])]));
}
//# sourceMappingURL=generateSwitchCase.js.map