'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

function extractTypeNames(typeAnnotation) {
    var result = [];
    switch (typeAnnotation.type) {
        case 'GenericTypeAnnotation':
            result.push(typeAnnotation.id.name);
            break;
        case 'UnionTypeAnnotation':
            typeAnnotation.types.forEach(function (type) {
                result = result.concat(extractTypeNames(type));
            });
            break;
        default:
    }
    return result;
}

var getTypesFromClassMethodsVisitor = {
    'ObjectMethod|ClassMethod': function ObjectMethodClassMethod(path, state) {
        var node = path.node;
        if (node === state.skipProp) {
            return;
        }
        var params = node.params;
        var key = node.key;
        var param = params[state.argNum];
        if (key.name[0] !== '_' && param) {
            state.types.push({
                types: extractTypeNames(param.typeAnnotation.typeAnnotation),
                method: node.key.name
            });
        }
    }
};

exports.default = getTypesFromClassMethodsVisitor;
//# sourceMappingURL=getTypesFromClassMethodsVisitor.js.map