'use strict';

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; })();

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = patternMatchingBabelPlugin;

var _findReducerPropertyVisitor = require('./findReducerPropertyVisitor');

var _findReducerPropertyVisitor2 = _interopRequireDefault(_findReducerPropertyVisitor);

var _getTypesFromClassMethodsVisitor = require('./getTypesFromClassMethodsVisitor');

var _getTypesFromClassMethodsVisitor2 = _interopRequireDefault(_getTypesFromClassMethodsVisitor);

var _generateSwitchCase = require('./generateSwitchCase');

var _generateSwitchCase2 = _interopRequireDefault(_generateSwitchCase);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function patternMatchingBabelPlugin(_ref) {
    var t = _ref.types;

    return {
        visitor: {
            'ClassDeclaration|ObjectExpression': function ClassDeclarationObjectExpression(path) {
                var state = {
                    reducerLabel: 'babelPatternMatch',
                    prop: null,
                    expressionParentPath: null,
                    expression: null
                };
                path.traverse(_findReducerPropertyVisitor2.default, state);
                if (!state.expression) {
                    return;
                }
                var prop = state.prop;
                var expression = state.expression;

                var args = prop.node.params;

                var _expression$arguments = _slicedToArray(expression.arguments, 2);

                var switchArg = _expression$arguments[0];
                var container = _expression$arguments[1];

                var argNum = args.findIndex(function (_ref2) {
                    var name = _ref2.name;
                    return name === switchArg.name;
                });
                var typesState = {
                    types: [],
                    skipProp: prop.node,
                    argNum: argNum
                };
                if (path.isProgram()) {
                    prop.traverse(_getTypesFromClassMethodsVisitor2.default, typesState);
                } else {
                    path.traverse(_getTypesFromClassMethodsVisitor2.default, typesState);
                }
                var thisRef = undefined;
                if (path.isProgram() && prop.node.type === 'FunctionDeclaration') {
                    thisRef = path.scope.generateUidIdentifier(prop.node.id.name);
                    prop.insertBefore(t.variableDeclaration('const', [t.variableDeclarator(thisRef, container)]));
                } else if (path.isObjectExpression()) {
                    thisRef = container || path.parent.id;
                } else if (path.isClassDeclaration()) {
                    thisRef = container || (prop.node.static ? path.node.id : t.thisExpression());
                }

                var switchCase = (0, _generateSwitchCase2.default)({
                    args: args,
                    switchArg: switchArg,
                    t: t,
                    thisRef: thisRef,
                    typesMap: typesState.types
                });
                state.expressionParentPath.replaceWith(switchCase);
            }
        }
    };
}
//# sourceMappingURL=patternMatchingBabelPlugin.js.map